// Tunnel 8-bit TeBe/Madteam (14.05.2006 - 04.12.2012)

unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  ComCtrls, ExtCtrls, StdCtrls, BMDSpinEdit, Math;

type
  TForm1 = class(TForm)
    Image3: TImage;
    seAddX: TBMDSpinEdit;
    seAddY: TBMDSpinEdit;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    TabSheet3: TTabSheet;
    Image1: TImage;
    Image2: TImage;
    seCircle: TBMDSpinEdit;
    seRays: TBMDSpinEdit;
    seDepth: TBMDSpinEdit;
    seOriginX: TBMDSpinEdit;
    seOriginY: TBMDSpinEdit;
    seOriginZ: TBMDSpinEdit;
    seDirectionZ: TBMDSpinEdit;
    seTextureWidth: TBMDSpinEdit;
    seRadius: TBMDSpinEdit;
    seDirectionZ3: TBMDSpinEdit;
    seDepth3: TBMDSpinEdit;
    cbCeilingFloor: TCheckBox;
    TabSheet4: TTabSheet;
    seConeSizeX: TBMDSpinEdit;
    seConeSizeY: TBMDSpinEdit;
    seConeSizeZ: TBMDSpinEdit;
    Button1: TButton;
    seConeAngle: TBMDSpinEdit;
    seConeTextureWidth: TBMDSpinEdit;
    cbMove: TCheckBox;
    cbSin: TCheckBox;
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure seCircleChange(Sender: TObject);
    procedure seRaysChange(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure PageControl1Change(Sender: TObject);
    procedure seOriginXChange(Sender: TObject);
    procedure seDirectionZ3Change(Sender: TObject);
    procedure Image3Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;


var
  Form1: TForm1;

  tab1, tab2, lut: array [0..127,0..127] of byte;

  texture: array [0..15,0..15] of TColor;

  aborted: Boolean = true;

const
 mx = 128;
 my = 128;

implementation

{$R *.dfm}


procedure TForm1.FormCreate(Sender: TObject);
begin
 seCircleChange(self);
 seRaysChange(self);

 image3.Canvas.TextOut(0,128,'Press LEFT MOUSE button to START/STOP animation');
end;


procedure TForm1.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
 if chr(Key)=#27 then Aborted:=true;
end;


procedure TForm1.PageControl1Change(Sender: TObject);
begin

 case PageControl1.TabIndex of
  0: begin                         // TUNNEL #1
      seCircleChange(self);
      seRaysChange(self);
     end;

  1: seOriginXChange(self);        // TUNNEL #2

  2: seDirectionZ3Change(self);    // TUNNEL #3

  3: Button1Click(self);

 end;

end;

(*----------------------------------------------------------------------------*)
(* CIRCLE                                                                     *)
(*----------------------------------------------------------------------------*)

procedure circle(x,y,r:integer; c:byte);
var st, pr, st2, pr2: real;
    a, ile: integer;
    px, py: integer;
begin

st:=0.1; pr:=0; ile:=round(360/st);

st2:=0.1;  pr2:=0;

  for a:=0 to ile-1 do begin

   px:= x+round(sin(pr*pi/180)*r);
   py:= y+round(cos(pr2*pi/180)*r);

   if (px in [0..127]) and (py in [0..127]) then tab1[px,py]:=(c and $f);

   pr:=pr+st;
   pr2:=pr2+st2;
  end;
end;

(*----------------------------------------------------------------------------*)
(* BRESENHAM LINE                                                             *)
(*----------------------------------------------------------------------------*)

procedure Line(x1, y1, x2, y2 : integer; color : byte);
var i, deltax, deltay, numpixels,
    d, dinc1, dinc2,
    x, xinc1, xinc2,
    y, yinc1, yinc2 : integer;
begin

  { Calculate deltax and deltay for initialisation }
  deltax := abs(x2 - x1);
  deltay := abs(y2 - y1);

  { Initialize all vars based on which is the independent variable }
  if deltax >= deltay then
    begin

      { x is independent variable }
      numpixels := deltax + 1;
      dinc1 := deltay Shl 1;
      d := dinc1 - deltax;
      dinc2 := (deltay - deltax) shl 1;
      xinc1 := 1;
      xinc2 := 1;
      yinc1 := 0;
      yinc2 := 1;
    end
  else
    begin

      { y is independent variable }
      numpixels := deltay + 1;
      dinc1 := deltax Shl 1;
      d := dinc1 - deltay;
      dinc2 := (deltax - deltay) shl 1;
      xinc1 := 0;
      xinc2 := 1;
      yinc1 := 1;
      yinc2 := 1;
    end;

  { Make sure x and y move in the right directions }
  if x1 > x2 then
    begin
      xinc1 := - xinc1;
      xinc2 := - xinc2;
    end;
  if y1 > y2 then
    begin
      yinc1 := - yinc1;
      yinc2 := - yinc2;
    end;

  { Start drawing at <x1, y1> }
  x := x1;
  y := y1;

  { Draw the pixels }
  for i := 1 to numpixels do
    begin

      if (x in [0..127]) and (y in [0..127]) then
       tab2[x, y]:= (color shr 4) {and $0f};

      if d < 0 then
        begin
          d := d + dinc1;
          x := x + xinc1;
          y := y + yinc1;
        end
      else
        begin
          d := d + dinc2;
          x := x + xinc2;
          y := y + yinc2;
        end;
    end;
end;


procedure SaveLUT;
var f: integer;
begin

 f:=FileCreate('tunnel.dat');
 FileWrite(f, lut, sizeof(lut));
 FileClose(f);

 Screen.Cursor := crDefault;

end;


procedure CreateLUT;
var i,j: integer;
begin

 for j:=0 to 127 do
  for i:=0 to 127 do
   lut[i,j] := (tab1[i,j] and $0f) or (tab2[i,j] shl 4);

 SaveLUT;

end;


(*----------------------------------------------------------------------------*)
(* TUNNEL - METHOD #1  RAYs and CIRCLEs                                       *)
(*----------------------------------------------------------------------------*)

procedure lines(x,y:integer);
var st, pr: real;
    a, ile, r, px, py, dv: integer;
begin

 dv:=form1.seRays.Position;

 r:=320;

 st:=0.1; pr:=0; ile:=round(360/st);

  for a:=0 to ile-1 do begin

   px:= x+round(sin(pr*pi/180)*r);
   py:= y+round(cos(pr*pi/180)*r);

   line(x,y,px,py, a shr dv);

   pr:=pr+st;
  end;

end;


procedure TForm1.seCircleChange(Sender: TObject);
// CIRCLEs
var i, j, add: integer;
    pr: real;
    c: byte;
begin

 Screen.Cursor := crHourGlass;

 add:=seCircle.Position;

 with image1.Canvas do begin
  Pen.Color:=0; Brush.Color:=0;
  rectangle(0,0,image1.Width,image1.Height);

  pr:=0;

  for i:=320 downto 0 do begin
   circle( image1.Width shr 1, image1.Height shr 1, i , round(pr));

   pr:=pr+ (1/(i+add)*seDepth.Position);
  end;

 end;

 for j:=0 to my-1 do
  for i:=0 to mx-1 do begin
   c:=tab1[i,j] shl 4;
   image1.Canvas.Pixels[i,j]:=rgb(c,c,c);
  end;

 CreateLUT;

end;


procedure TForm1.seRaysChange(Sender: TObject);
// RAYs
var i, j, c: byte;
begin

 Screen.Cursor := crHourGlass;

 with image2.Canvas do begin
  Pen.Color:=0; Brush.Color:=0;
  rectangle(0,0,image2.Width,image2.Height);

  for i:=0 to 130 do begin
   lines( image2.Width shr 1 , image2.Height shr 1);
  end;

 end;

 for j:=0 to my-1 do
  for i:=0 to mx-1 do begin
   c:=tab2[i,j] shl 4;
   image2.Canvas.Pixels[i,j]:=rgb(c,c,c);
  end;

 CreateLUT;

end;


(*----------------------------------------------------------------------------*)
(* TUNNEL - METHOD #2  ArcTan2 (copy half LUT table or quarter)               *)
(*----------------------------------------------------------------------------*)

procedure TForm1.seOriginXChange(Sender: TObject);
var i,j, radius: integer;
    len, delta, t,t1,t2, a,b,c,sn: double;
    u,v:byte;

    origin, direction, Intersection:
                       record
                        x,y,z: double;
                       end;

begin

 Screen.Cursor := crHourGlass;

 origin.x := seOriginX.Position;
 origin.y := seOriginY.Position;
 origin.z := seOriginZ.Position;

 radius   := seRadius.Position;

  for j:=0 to my-1 do
      for i:=0 to mx-1 do begin

          if cbSin.Checked then  
           sn:=2*sin(j*(360/mx)*pi/180)
          else
           sn:=1;

          direction.x:=i-(mx div 2);
          direction.y:=j-(my div 2);
          direction.z:=seDirectionZ.Position;

          len:=sqrt(sqr(direction.x)+sqr(direction.y)+sqr(direction.z));

          direction.x:=(direction.x/len);
          direction.y:=(direction.y/len);
          direction.z:=(direction.z/len);

          a := sqr(Direction.x) + sqr(Direction.y);
          b := 2*(Origin.x*Direction.x + Origin.y*Direction.y);
          c := sqr(Origin.x) + sqr(Origin.y) - sqr(Radius * sn);

          delta := sqr(b) - 4*a*c;

          if delta < 0 then begin      // if there's no real solution

           u:=0;
           v:=0;

          end else begin

           if a=0 then begin

            t1:=0;
            t2:=0;

           end else begin

            t1 := (-b + sqrt(delta))/(2*a);
            t2 := (-b - sqrt(delta))/(2*a);
            t  := min(t1, t2);

           end;

           Intersection.x:=origin.x+t*direction.x;
           Intersection.y:=origin.y+t*direction.y;
           Intersection.z:=origin.z+t*direction.z;
          end;

          u := round(-(Intersection.z)*0.2);
          v := round(-(ArcTan2(Intersection.y, Intersection.x)*seTextureWidth.Position/PI));

          lut[i,j] := (round( u ) mod 16) or (round( v ) mod 16) shl 4;

        end;

 SaveLUT;

end;


(*----------------------------------------------------------------------------*)
(* TUNNEL - METHOD #3                                                         *)
(*----------------------------------------------------------------------------*)

procedure TForm1.seDirectionZ3Change(Sender: TObject);
var i,j: integer;
    dl, k,l,m, n, x,y,z, a: double;
begin

  Screen.Cursor := crHourGlass;

  for j:=0 to my-1 do
   for i:=0 to mx-1 do begin

    k:=i-(mx div 2);
    l:=j-(my div 2);
    m:=seDirectionZ3.Position;

    dl:=sqrt(k*k+l*l+m*m);

    if dl=0 then dl:=1;

    k:=k/dl;
    l:=l/dl;
    m:=m/dl;

    if cbCeilingFloor.Checked then
     a:=l*l
    else
     a:=k*k+l*l;

    if a=0 then
     n:=1
    else
     n:=sqrt(seDepth3.Position/a);     {punkt przeciecia z walcem}

    x:=k*n;
    y:=l*n;
    z:=m*n;

//    lut[i,j]:=(round(z) mod 16) or (round(arctan2(x,y)*32) mod 16) shl 4;
    lut[i,j]:=round(z) mod 16 or (round(x) mod 16) shl 4;

   end;

 SaveLUT;

end;


(*----------------------------------------------------------------------------*)
(* WORMHOLE                                                                   *)
(*----------------------------------------------------------------------------*)

procedure Wormhole;
var i,j,tx,ty,sx,sy, xsro, ysro, xx,yy: integer;
    x,step_y,step_x,u,v,theta,phi,tempx,tempy,tempz: double;
    y, tmp_y, rad: double;
    cone_size_x, cone_size_y, cone_size_z, cone_angle, texture_width: integer;

begin

 Screen.Cursor := crHourGlass;

 fillchar(lut, sizeof(lut), 0);

 rad:=pi/180;

 cone_size_x:=form1.seConeSizeX.Position;
 cone_size_y:=form1.seConeSizeY.Position;
 cone_size_z:=form1.seConeSizeZ.Position;

 cone_angle :=form1.seConeAngle.Position;

 texture_width:=form1.seConeTextureWidth.Position;

 xsro:=mx div 2;
 ysro:=my div 2; 

 tmp_y:=120;

 for yy := 0 to my-1 do begin
 for xx := 0 to mx-1 do begin

 y:=tmp_y;
 step_y:=0;

 for j:=0 to round(16/(step_y+1)) do begin    // modyfikacja przyspieszajaca obliczenia

   y:=y-step_y;
   x:=0;
   step_x:=xx;

   for i:=0 to 80 do begin

    x:=x+step_x;

    step_x:=0.065+(0.4*y/100);
    step_y:=0.065+(0.4*y/100);

    tx:=round(x/100*texture_width);         { * szerokosc textury }
    ty:=round(y/100*texture_width);

    u:=x/100;                     { liczba kafli textury po okregu }
    v:=y/100;

    theta:=u*360*rad;
    phi:=v;

    tempx:=cone_size_x*cos(theta);
    tempy:=cone_size_y*sin(theta);
    tempz:=cone_size_z*phi;

    sx:=round(tempx * xsro/(tempz + 150) + xsro);
    sy:=round((tempy*cos(phi*cone_angle*rad)+tempz*sin(phi*cone_angle*rad)) * xsro/(tempz+150)+ysro);

    if (sx in [0..mx-1]) and (sy in [0..my-1]) then lut[sx,sy]:=abs(tx) mod 16+(ty mod 16) shl 4;

   end;

 end;

 end;

 tmp_y:=y;
 end;

 SaveLUT;

end;


procedure TForm1.Button1Click(Sender: TObject);
begin

 Wormhole;

end;


(*----------------------------------------------------------------------------*)
(* TUNNEL - MAIN LOOP                                                         *)
(*----------------------------------------------------------------------------*)

procedure TForm1.Image3Click(Sender: TObject);
// TUNNEL
var i, j, add_x, add_y, u,v, k, px,py, ang: byte;
    bmp: TBitmap;

const
 MaxX = 64;
 MaxY = 64;

begin

 Aborted:=not(Aborted);

{ LOAD TEXTURE }
 bmp:=TBitmap.Create;

 bmp.LoadFromFile('doom16.bmp');

 for j:=0 to 15 do
  for i:=0 to 15 do texture[i,j] := bmp.Canvas.Pixels[i,j];

 bmp.Width:=64;
 bmp.Height:=64;

 bmp.PixelFormat:=pf24bit;


{ MAIN LOOP }

add_x:=0;
add_y:=0;

px:=0;
py:=0;

ang:=0;

repeat

 sleep(50);

 Application.ProcessMessages;
 if Aborted then Break;

 for j:=0 to MaxY-1 do
  for i:=0 to MaxX-1 do begin

   k:=lut[ (i+px+32) mod 128 , (j+py+32) mod 128 ];

   u:=(k and $0f + add_x) mod 16;
   v:=(k shr 4 + add_y) mod 16;

   bmp.Canvas.Pixels[i,j] := texture[u,v];

  end;

  inc(add_x, form1.seAddX.Position);
  inc(add_y, form1.seAddY.Position);

  if form1.cbMove.Checked then begin
   px:=round(sin(ang*360/256*pi/180)*32);
   py:=round(cos(ang*360/256*pi/180+16)*32);
  end else begin
   px:=0;
   py:=0;
  end;

  inc(ang,4);

  form1.image3.Picture.Graphic:=bmp;

until false;

 bmp.Free;
end;

end.
